#ifndef _UART_H_
#define _UART_H_

#include <avr/io.h>


extern void uart_init();

static inline int
uart_putc (const uint8_t c)
{
    // Warten, bis UDR bereit ist fr einen neuen Wert 
    while (!(UCSRA & (1 << UDRE)))
        ;

    // UDR Schreiben startet die bertragung 
    UDR = c;

    return 1;
}

static inline uint8_t
uart_getc_wait()
{
    // Warten, bis etwas empfangen wird 
    while (!(UCSRA & (1 << RXC)))
        ;

    // Das empfangene Zeichen zurckliefern 
    return UDR;
}

static inline int
uart_getc_nowait()
{
    // Liefert das empfangene Zeichen, falls etwas empfangen wurde; -1 sonst 
    return (UCSRA & (1 << RXC)) ? (int) UDR : -1;
}





#endif /* _UART_H_  */
